#include <windows.h>
#include "input.h"
#include "launcher.h"
#include <stdio.h>

BOOL joyPresent;
UINT xMin, xMax, yMin, yMax;

BOOL keyPressed(int keyCode) {
	SHORT keyState;

	if (inputEnabled) {
		keyState = GetAsyncKeyState(keyCode);
		return (keyState & 0x1 || ((keyState >> 15) & 0x1));
	} else
		return FALSE;
}

BOOL joyInPosition(int position) {
	JOYINFO joyInfo;
	
	if (useJoystick && joyPresent) {
		memset(&joyInfo, 0, sizeof(joyInfo));
		if (joyGetPos(JOYSTICKID1, &joyInfo) == JOYERR_NOERROR) {
			switch (position) {
				case JOY_X_UP:
					return (joyInfo.wXpos >= xMax - .2 * xMax);
					break;
				case JOY_X_DOWN:
					return (joyInfo.wXpos <= xMin + .2 * xMax);
					break;
				case JOY_Y_UP:
					return (joyInfo.wYpos >= yMax - .2 * yMax);
					break;
				case JOY_Y_DOWN:
					return (joyInfo.wYpos <= yMin + .2 * yMax);
					break;
				case JOY_BUTTON_1:
					return (joyInfo.wButtons & JOY_BUTTON1);
					break;
				case JOY_BUTTON_2:
					return (joyInfo.wButtons & JOY_BUTTON2);
					break;
				case JOY_BUTTON_3:
					return (joyInfo.wButtons & JOY_BUTTON3);
					break;
				case JOY_BUTTON_4:
					return (joyInfo.wButtons & JOY_BUTTON4);
					break;
				default:
					return FALSE;
			}
		} else {
			printf("Error reading joystick!\n");
			return FALSE;
		}
	} else
		return FALSE;
}

void inputInit() {
	JOYINFOEX joyInfoEx;
	JOYCAPS joyCaps;
	
	memset(&joyInfoEx, 0, sizeof(joyInfoEx));
	joyInfoEx.dwSize = sizeof(joyInfoEx);
	joyPresent = (joyGetPosEx(JOYSTICKID1, &joyInfoEx) == JOYERR_NOERROR);
	
#if DEBUG
	printf("Joystick present: %i\n", joyPresent);
#endif
	
	memset(&joyInfoEx, 0, sizeof(joyInfoEx));
	joyInfoEx.dwSize = sizeof(joyInfoEx);
	
	// see whether a throttle is available
	joyGetDevCaps(JOYSTICKID1, &joyCaps, sizeof(joyCaps));
	xMin = joyCaps.wXmin;
	xMax = joyCaps.wXmax;
	yMin = joyCaps.wYmin;
	yMax = joyCaps.wYmax;
	
#if DEBUG==2
	printf("Joystick X min/max: %i/%i\n", xMin, xMax);
	printf("Joystick Y min/max: %i/%i\n", yMin, yMax);
#endif
	
}
