#include <windows.h>
#include <string.h>
#include "mame.h"
#include "launcher.h"
#include "mameparser.h"
#include "drawing.h"
#include <stdio.h>

BOOL _execCommand(char *command, char *workingDir, LPSTARTUPINFO si, LPSECURITY_ATTRIBUTES sa, DWORD *exitCode, BOOL launchingMame) {
	PROCESS_INFORMATION proc;
	char *message;
	int i;

#if DEBUG
	printf("Launching: [%s]\n", command);
#endif
	if (CreateProcess(NULL, command, sa, FALSE, TRUE, FALSE, FALSE, workingDir, si, &proc)) {

        	// wait a moment then send key to get past "press a key to continue"
			if(launchingMame == TRUE) {
				Sleep( 1000 );
				keybd_event( 0x5a, 0, 0, 0 );
				keybd_event( 0x5a, 0, KEYEVENTF_KEYUP, 0 );
			}

        	// Wait for the shelled application to finish
        	WaitForSingleObject(proc.hProcess, INFINITE);
        	if (exitCode)
        		if (!GetExitCodeProcess(proc.hProcess, exitCode))
        			MessageBox(hwndMain, "GetExitCodeProcess failed!", "Error", MB_OK);
        	CloseHandle(proc.hProcess);
        	CloseHandle(proc.hThread);
        	SetConsoleTitle(VERSION);
        	for (i=0; i<255; i++) GetAsyncKeyState(i);
			return TRUE;
        } else {
        	message = (char *)malloc(50 + strlen(command));
        	sprintf(message, "Failed to execute [%s]!", command);
#if DEBUG
		printf("Failed to execute [%s]!\n", command);
#endif
        	MessageBox(hwndMain, message, "Error", MB_OK);
        	free(message);
        	SetConsoleTitle(VERSION);
        	for (i=0; i<255; i++) GetAsyncKeyState(i);
        	return FALSE;
        }
}

BOOL execCommandToOutputFile(char *command, char *workingDir, char *outputFilename, DWORD *exitCode) {
	HANDLE hFile;
	SECURITY_ATTRIBUTES sa;
	STARTUPINFO si;
	char *message;
	BOOL retval;

	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	sa.lpSecurityDescriptor = NULL;
	sa.bInheritHandle = TRUE;

	hFile = CreateFile(outputFilename, GENERIC_WRITE, FILE_SHARE_READ, &sa, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
	if (hFile == INVALID_HANDLE_VALUE) {
        	message = (char *)malloc(50 + strlen(outputFilename));
        	sprintf(message, "Failed to create file [%s]!", outputFilename);
#if DEBUG
		printf("%s\n", message);
#endif
        	MessageBox(hwndMain, message, "Error", MB_OK);
        	free(message);
        	return FALSE;
        }

	memset(&si, 0, sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO);
	si.hStdInput = GetStdHandle(STD_INPUT_HANDLE);
	si.hStdOutput = hFile;
	si.hStdError = hFile;
	si.dwFlags = STARTF_USESHOWWINDOW | STARTF_USESTDHANDLES;
	si.wShowWindow = SW_HIDE;

	retval = _execCommand(command, workingDir, &si, &sa, exitCode, FALSE);

	CloseHandle(hFile);

	return retval;
}

BOOL execCommand(char *command, char *workingDir, DWORD *exitCode, BOOL launchingMAME) {
	STARTUPINFO si;
	SECURITY_ATTRIBUTES sa;

	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	sa.lpSecurityDescriptor = NULL;
	sa.bInheritHandle = TRUE;

	memset(&si, 0, sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO);
	si.dwFlags = STARTF_USESHOWWINDOW;
	si.wShowWindow = SW_HIDE;

	return _execCommand(command, workingDir, &si, &sa, exitCode, launchingMAME);
}


/* Rewritten by Pete Rittwage on 10-5-2003
	It does not recognize merged sets */
void checkExistance() {
	int i,total=0;
	char *romSearch;

	for (i=0; i<gameCount; i++) {

			// start with no games existing
			gameList[i]->exists = FALSE;

			sprintf(romSearch, "%s\\%s.zip", romsDir,gameList[i]->romname);

			if (fileExists(romSearch)) {  	// does rom not exist (split set)
				gameList[i]->exists = TRUE;
				total++;
			}
			else {
				sprintf(romSearch, "%s\\%s.zip", romsDir,gameList[i]->cloneof);
				if (fileExists(romSearch)) {  	// does rom not exist (split set)
							gameList[i]->exists = TRUE;
					total++;
				}
			}
			#if DEBUG
				if(gameList[i]->exists == FALSE) printf("missing %s\n",romSearch);
			#endif
	}
	#if DEBUG
		printf("Total detected: %d",total);
	#endif
}

void buildDisplayGameList() {
	int i;

	// Remove the old list if there is one
	if (gameDisplayList) {
		free(gameDisplayList);
		gameDisplayList = NULL;
	}
	gameDisplayCount = 0;

	for (i=0; i<gameCount; i++) {
		if (!(	// Choose the roms not to display
			gameList[i]->isResource || 							// Don't display bios roms
			(!displayMissingRoms && !gameList[i]->exists) ||	// Game must exist on filesystem
			(!displayMissingRoms &&								// If it's a clone, parent must exist on filesystem
				!(!gameList[i]->cloneof || (gameList[i]->cloneof && gameList[i]->parent->exists))) ||

			(!displayVerticalRoms && gameList[i]->video->orientation==VERTICAL) ||		// Don't display vertical roms
			(!displayHorizontalRoms && gameList[i]->video->orientation==HORIZONTAL) ||	// Don't display horizontal roms
			(!displayClones && gameList[i]->cloneof) ||					// Don't display clones
			gameList[i]->input->players < minPlayers ||					// Filter on number of players
			gameList[i]->input->players > maxPlayers ||
			gameList[i]->input->buttons < minButtons ||					// Filter on number of buttons
			gameList[i]->input->buttons > maxButtons ||
			gameList[i]->input->coins < minCoins ||						// Filter on number of coin slots
			gameList[i]->input->coins > maxCoins ||
			((gameList[i]->input->control & controllerTypes) == 0) ||	// Filter on controller type
			(!displayNeoGeo && gameList[i]->romof && !strcmp(gameList[i]->romof, "neogeo")) ||	// Filter on neogeo games
			(!displayNonNeoGeo && (								// Filter on non-neogeo games
				(gameList[i]->romof && strcmp(gameList[i]->romof, "neogeo")) ||
				!gameList[i]->romof
			)) ||
			(!displayVector && gameList[i]->video->screen && !strcmp(gameList[i]->video->screen, "vector")) ||	// Filter on vector games
			(!displayRaster && gameList[i]->video->screen && !strcmp(gameList[i]->video->screen, "raster"))		// Filter on raster games
		)) {
#if DEBUG==2
			printf("Displaying #%i: %s\n", i, gameList[i]->romname);
#endif
			gameDisplayList = (GAME **)realloc(gameDisplayList, sizeof(GAME *) * ++gameDisplayCount);
			gameDisplayList[gameDisplayCount - 1] = gameList[i];
		}
#if DEBUG
		else printf("Not displaying #%i: %s\n", i, gameList[i]->romname);
#endif
	}
#if DEBUG
	printf("Displayed game count: %i\n", gameDisplayCount);
#endif
}

int qsortCompare(const void *g1, const void *g2) {
	GAME *ga = *(GAME * const *)g1;
	GAME *gb = *(GAME * const *)g2;
	char yeara[10], yearb[10];

	if(!ga->year) ga->year=9999;
	if(!gb->year) gb->year=9999;
	itoa(ga->year,yeara,10);
	itoa(gb->year,yearb,10);

	if(sortBy==SORTBY_YEAR) {
		if(!strcmp(yeara, yearb))  // Same year, sort manufacturer
			if(!strcmp(ga->manufacturer, gb->manufacturer)) // Same manufacturer, sort name
				return strcmp(ga->description, gb->description);
			else
				return strcmp(ga->manufacturer, gb->manufacturer);
		else
			return strcmp(yeara, yearb);
	}
	else if(sortBy==SORTBY_MANUFACTURER) {
		if(!strcmp(ga->manufacturer, gb->manufacturer)) // Same manufacturer, sort year
			if(!strcmp(yeara, yearb))  // Same year, sort name
				return strcmp(ga->description, gb->description);
			else
				return strcmp(yeara, yearb);
		else
			return strcmp(ga->manufacturer, gb->manufacturer);
	}
	else
		return strcmp(ga->description, gb->description);
}

BOOL launchMame(GAME *game, DWORD *exitCode) {
	char workingDir[255];
	char launchOptions[255];
	char command[255];
	char *slash;
	BOOL retval;

	strcpy(workingDir, mameExe);

	if(workingDir[1] != ":")
		GetModuleFileName(0,workingDir,255);

#if DEBUG
	printf("workingDir: %s\n",workingDir);
#endif

	slash = strrchr(workingDir, '\\');
	*slash = 0;

	// Get any special launch parameters for this game (or its parent)
	GetPrivateProfileString("Mameoptions", game->romname, "", launchOptions, 255, iniFilename);
	if (strlen(launchOptions) == 0 && game->cloneof != NULL)
		GetPrivateProfileString("Mameoptions", game->cloneof, "", launchOptions, 255, iniFilename);

	if (strlen(launchOptions) == 0)
		sprintf(command, "%s %s", mameExe, game->romname);
	else
		sprintf(command, "%s %s %s", mameExe, game->romname, launchOptions);

	// Disable the screensaver while mame is running
	SystemParametersInfo (SPI_SETSCREENSAVEACTIVE, FALSE, NULL, 0);

	// Launch mame
	retval = execCommand(command, workingDir, exitCode, TRUE);

	// Enable the screensaver again
	SystemParametersInfo (SPI_SETSCREENSAVEACTIVE, TRUE, NULL, 0);

	return retval;
}


// This is slow, but it should be used so rarely it's not worth speeding up
int findDisplayGameIndex(char *romname) {
	int i;

	for (i=0; i<gameDisplayCount; i++)
		if (strcmp(romname, gameDisplayList[i]->romname) == 0)
			return i;

	return -1;
}
